﻿Type=Service
Version=2.71
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private streamer As AudioStreamer
	Dim buffers As List
	
	Private output As OutputStream
	Private mBitRate As Int = 16
	Private mSampleRate As Int = 22050
	Private mMono As Boolean = True
	
End Sub

Sub Service_Create
	streamer.Initialize("streamer", mSampleRate, mMono, mBitRate, streamer.VOLUME_MUSIC)
	buffers.Initialize
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Sub Service_Destroy

End Sub

Sub streamer_RecordBuffer (Buffer() As Byte)
	
	If Main.recording Then output.WriteBytes(Buffer, 0, Buffer.Length)
	'the above check is required as the last message will arrive after we call StopRecording.

End Sub

Sub btnStartRecording_Click

	buffers.Clear
	output = StartWaveFile(File.DirRootExternal, Main.mFileName, mSampleRate, mMono, mBitRate)
	streamer.StartRecording
	
End Sub

Sub btnStopRecording_Click

	streamer.StopRecording
	output.Close
	CloseWaveFile(File.DirRootExternal, Main.mFileName)

End Sub

Sub StartWaveFile(Dir As String, FileName As String, SampleRate As Int, Mono As Boolean _
		, BitsPerSample As Int) As OutputStream
	File.Delete(Dir, FileName)
	Dim raf As RandomAccessFile
	raf.Initialize2(Dir, FileName, False, True)
	raf.WriteBytes("RIFF".GetBytes("ASCII"), 0, 4, raf.CurrentPosition)
	raf.CurrentPosition = 8 'skip 4 bytes for the size
	raf.WriteBytes("WAVE".GetBytes("ASCII"),0, 4, raf.CurrentPosition)
	raf.WriteBytes("fmt ".GetBytes("ASCII"),0, 4, raf.CurrentPosition)
	raf.WriteInt(16, raf.CurrentPosition)
	raf.WriteShort(1, raf.CurrentPosition)
	Dim numberOfChannels As Int
	If Mono Then numberOfChannels = 1 Else numberOfChannels = 2
	raf.WriteShort(numberOfChannels, raf.CurrentPosition)
	raf.WriteInt(SampleRate, raf.CurrentPosition)
	raf.WriteInt(SampleRate * numberOfChannels * BitsPerSample / 8, raf.CurrentPosition)
	raf.WriteShort(numberOfChannels * BitsPerSample / 8, raf.CurrentPosition)
	raf.WriteShort(BitsPerSample, raf.CurrentPosition)
	raf.WriteBytes("data".GetBytes("ASCII"),0, 4, raf.CurrentPosition)
	raf.WriteInt(0, raf.CurrentPosition)
	raf.Close
	Return File.OpenOutput(Dir, FileName, True)
End Sub

Sub CloseWaveFile(Dir As String, FileName As String)
	Dim raf As RandomAccessFile
	raf.Initialize2(Dir, FileName, False, True)
	raf.WriteInt(raf.Size - 8, 4)
	raf.WriteInt(raf.Size - 44, 40)
	raf.Close
End Sub

